diff -r 1e55e1aa8b7f sys/netinet/tcp_input.c
--- a/sys/netinet/tcp_input.c	Sun May 04 01:33:02 2014 +0000
+++ b/sys/netinet/tcp_input.c	Fri Jul 11 13:32:06 2014 +1000
@@ -1587,11 +2004,485 @@
 	}
 
 	/*
+	 * Do we need to send a data-level ACK in response to this segment?
+	 */
+	if (to.to_mopts.mpo_flags & MPOF_NEED_ACK) {
+		tp->sf_flags |= SFF_NEED_DACK;
+		tp->t_flags |= TF_ACKNOW;
+	}
+
+	/*
+	 * Got MP_JOIN option. If the length is correct tcp_output
+	 * will check this flag for MPOF_MP_JOIN and send a SYNACK
+	 * with MP_JOIN option. Otherwise just discard the segment.
+	 */
+	if (to.to_mopts.mpo_flags & MPOF_JOIN_SYN) {
+		mp_debug(MPSESSION, 2, 0, "%s: got JOIN_SYN\n", __func__);
+		/*
+		 * Got a MP_JOIN_SYN option. Need to send a JOIN_SYNACK
+		 * in reponse.
+		 */
+		if (to.to_mopts.optlen != MPTCP_SUBLEN_MP_JOIN_SYN) {
+			to.to_mopts.mpo_flags &= ~MPOF_MP_JOIN;
+			goto dropwithreset;
+		}
+
+		/* Syncache respond needs these for HMAC
+		 * tp for subflow is not in use at this point */
+		to.to_mopts.remote_key = mp->remote_key;
+		to.to_mopts.local_key = mp->local_key;
+
+		tp->sf_flags |= SFF_GOT_JOIN_SYN;
+	}
+	else if (to.to_mopts.mpo_flags & MPOF_JOIN_ACK) {
+		if (to.to_mopts.optlen == MPTCP_SUBLEN_MP_JOIN_ACK) {
+			/*
+			 * Got an ACK with MP_JOINACK in it. Go straight to established
+			 * since multipath is already active. We will also be sending an
+			 * ACK for this packet, which will put the active opener into
+			 * established for this subflow.
+			 */
+			tp->t_flags |= TF_ACKNOW;
+			tp->sf_flags |= SFF_GOT_JOIN_ACK;
+
+			//mp_init_established(tp);	//XXXNJW really worth a function call?
+			/* We can set the additional subflow as active right from here */
+			tp->mp_active = 1;
+			tp->infinite_map = 0;
+//			atomic_add_int(&tp->t_mpcb->subflow_cnt,1);
+			mp_debug(MPSESSION, 1, 0,"%s:%d new mp connection for tp: %p: \n",
+			    __func__, __LINE__, tp);
+			mp_debug(MPSESSION, 1, 0, "%s: subflow tp %p (slave to master tp %p) "
+			    "transitioning to MPS_ESTABLISHED\n", __func__, tp,
+			    tp->t_mpcb->master_tcpcb);
+		}
+	} /* End join processing */
+
+	/*
+	 * Got a new DSS mapping for this subflow.
+	 */
+	if ((to.to_mopts.mpo_flags & MPOF_DSS)) {
+		/*
+		 * Convert 32bit DS map start sequence numbers into 64 bit.
+		 */
+		if ((to.to_mopts.mpo_flags & MPOF_DSN64) == 0 &&
+		    (to.to_mopts.mpo_flags & MPOF_DSN_MAP)) {
+
+			/* XXX: need to think about what value to key the if block off
+			 * that doesn't require checking into mpcb */
+			if(tp->infinite_map) {
+				to.to_mopts.data_seq_num =
+				    (tp->t_mpcb->ds_idsr & 0xFFFFFFFF00000000) |
+					(uint32_t) to.to_mopts.data_seq_num;
+			} else {
+				to.to_mopts.data_seq_num =
+					(((tp->t_mpcb->ds_rcv_nxt) & 0xFFFFFFFF00000000)
+					| (uint32_t) to.to_mopts.data_seq_num);
+				if ((uint32_t)tp->t_mpcb->ds_rcv_nxt >
+				    (uint32_t)to.to_mopts.data_seq_num
+					&& ((uint32_t)to.to_mopts.data_seq_num & 0xC0000000) == 0
+					&& ((uint32_t)tp->t_mpcb->ds_rcv_nxt & 0xC0000000)
+					== 0xC0000000) {
+					mp_debug(MPSESSION, 4, 0, "%s: detected wrap on lower 32 "
+							"of ds_rcv_nxt %ju: %u, dsn map start %ju : %u\n",
+					    __func__, tp->t_mpcb->ds_rcv_nxt,
+					    (uint32_t)tp->t_mpcb->ds_rcv_nxt,
+					    to.to_mopts.data_seq_num,
+					    (uint32_t)to.to_mopts.data_seq_num);
+					to.to_mopts.data_seq_num += ((uint64_t)1 << 32);
+				}
+			}
+		}
+
+		if ((to.to_mopts.mpo_flags & MPOF_ACK64) == 0 &&
+		    (to.to_mopts.mpo_flags & MPOF_DATA_ACK)) {
+
+			/* We check the window field only on  D-ACK packets
+			 * if the window has changed, set tiwin to new window
+			 * and set the new window.
+			 */
+			if (th->th_win != tp->t_mpcb->ds_snd_wnd) {
+				tiwin = th->th_win << tp->snd_scale;
+				mp_update_sndwin(tp->t_mpcb, th->th_win);
+			}
+
+			if(tp->infinite_map)
+				to.to_mopts.data_ack_num = (tp->t_mpcb->ds_idsn & 0xFFFFFFFF00000000)
+					| (uint32_t) to.to_mopts.data_ack_num;
+			else {
+				to.to_mopts.data_ack_num =
+					(((tp->t_mpcb->ds_snd_una) & 0xFFFFFFFF00000000)
+					| (uint32_t) to.to_mopts.data_ack_num);
+				if ((uint32_t)tp->t_mpcb->ds_snd_una > (uint32_t)to.to_mopts.data_ack_num
+						&& ((uint32_t)to.to_mopts.data_ack_num & 0xC0000000) == 0
+						&& ((uint32_t)tp->t_mpcb->ds_snd_una & 0xC0000000) == 0xC0000000) {
+					mp_debug(MPSESSION, 4, 0, "%s: detected wrap on lower 32 of"
+							" ds_snd_una %ju : %u, data ack %ju : %u\n",
+					    __func__, tp->t_mpcb->ds_snd_una,
+					    (uint32_t)tp->t_mpcb->ds_snd_una,
+					    to.to_mopts.data_ack_num,
+					    (uint32_t)to.to_mopts.data_ack_num);
+					to.to_mopts.data_ack_num += ((uint64_t)1 << 32);
+				}
+			}
+
+		}
+
+		/*
+		 * XXXNJW: infinite map = 1 for new flows, so when we get the
+		 * first DSN on an active opener we can use it to set our
+		 * initial rcv_nxt. BUT what if we want to specify our own
+		 * ds_rcv number space (by advertising a D-ACK....)
+		 */
+
+		if (to.to_mopts.mpo_flags & MPOF_DATA_FIN) {
+			//tp->t_state = TCPS_CLOSE_WAIT;			//XXXNJW TODO
+		}
+
+		if (to.to_mopts.mpo_flags & MPOF_DSN_MAP) {
+			/* got a DSN with no length, drop to infinite mapping */
+			if (to.to_mopts.dss_data_len == 0)
+				panic("dropping back to infinite map not implemented\n");
+
+			struct ds_map *temp_map, *temp_map2, *next_map = NULL;
+			int found_dup_map = 0;
+
+			/* find the map that this segment belongs to */
+			TAILQ_FOREACH_SAFE(temp_map, &tp->t_rxdsmaps, sf_ds_map_next,
+					temp_map2) {
+
+				/* This is a completed map, so remove it from t_rxdmaps */
+				if (SEQ_GEQ(tp->rcv_nxt,temp_map->sf_seq_start
+					+ temp_map->ds_map_len)) {
+					mp_debug(DSMAP, 4, 0, "remove map: sf_seq_start: %u. "
+							"end: %u\n", temp_map->sf_seq_start,
+							temp_map->sf_seq_start + temp_map->ds_map_len);
+					TAILQ_REMOVE(&tp->t_rxdsmaps, temp_map, sf_ds_map_next);
+					free(temp_map, M_DSSMAP);
+					continue;
+				}
+
+				if (!next_map) {
+					tcp_seq new_sf_map_start =
+					    to.to_mopts.sub_seq_num + tp->irs;
+					tcp_seq temp_map_end =
+					    temp_map->sf_seq_start + temp_map->ds_map_len;
+
+					/* A segment part-way into an already recv'd mapping? */
+//					if (new_sf_map_start > temp_map->sf_seq_start &&
+//						to.to_mopts.data_seq_num == temp_map->ds_map_start) {
+					// XXXNJW this would be a broken mapping
+					// (SSN, DSN) out of sync
+
+					/* is this map fully contained within an existing map? */
+					if (new_sf_map_start > temp_map->sf_seq_start &&
+							(new_sf_map_start + to.to_mopts.dss_data_len <=
+							temp_map->sf_seq_start + temp_map->ds_map_len)) {
+
+						int map_offset = 0;
+						map_offset = new_sf_map_start - temp_map->sf_seq_start;
+
+						/* double check that DSNs are aligned, if so set dup */
+						if (temp_map->ds_map_start + map_offset ==
+						    to.to_mopts.data_seq_num) {
+							found_dup_map = 1;
+							map = temp_map;
+						}
+
+					}
+
+					/* An unseen map, therefore should be inserted before
+					 * temp_map in our map list */
+					if (new_sf_map_start >= temp_map_end &&
+						(temp_map_end > temp_map->sf_seq_start ||
+						(new_sf_map_start & 0xC0000000) == 0)) {
+						next_map = temp_map;
+					}
+
+					/* A duplicate of a map we have in the list */
+					if (to.to_mopts.data_seq_num == temp_map->ds_map_start) {
+						mp_debug(DSMAP, 4, 0, "%s: : sqn %u, dup map: %u "
+							"t_len: %d\n", __func__, th->th_seq,
+							(uint32_t) to.to_mopts.data_seq_num, tlen);
+						KASSERT(new_sf_map_start == temp_map->sf_seq_start
+							//&& to.to_mopts.dss_csum == temp_map->ds_map_csum
+							,("DSN number matches existing map "
+							 "but SSNs are not the same\n"));
+
+//						KASSERT(to.to_mopts.dss_data_len == temp_map->ds_map_len
+//								//&& to.to_mopts.dss_csum == temp_map->ds_map_csum
+//								,("SF sequence number matches existing map "
+//								 "but maps are not the same\n"));
+						found_dup_map = 1;
+						map = temp_map;
+					}
+				}
+
+			}
+
+
+			/*
+			 * XXXNJW: Need to think about coalescing mappings that overlap on
+			 * the right hand edge.
+			 */
+
+			/*
+			 * If we do not find a map covered by this sequence number,
+			 * allocate a new map and put into mapping list.
+			 * Also for cases where !has_dsn_map (map will be NULL
+			 * in this case)
+			 */
+			if (!found_dup_map) {
+
+				/* XXX: should use zone allocator */
+				map = malloc(sizeof(struct ds_map), M_DSSMAP, M_NOWAIT);
+
+				/* set values for mapping */
+				map->ds_map_start = to.to_mopts.data_seq_num;
+				map->sf_seq_start = to.to_mopts.sub_seq_num + tp->irs;
+				map->ds_map_len = map->ds_map_offset =
+					to.to_mopts.dss_data_len;
+				map->ds_map_csum = to.to_mopts.dss_csum;
+
+				mp_debug(DSMAP, 4, 0, "%s: inserting map sf_seq_start %u, "
+					"end %u seq: %u\n", __func__, map->sf_seq_start,
+					map->sf_seq_start + map->ds_map_len, th->th_seq);
+
+				/* if there are no existing maps insert at head. Other
+				 * wise insert in sequence */
+				if (next_map == NULL) {
+//					KASSERT(TAILQ_EMPTY(&tp->t_rxdsmaps),
+//						("Incoming sequence %u less than those in rx maps\n"));
+//					TAILQ_INSERT_HEAD(&tp->t_rxdsmaps, map, sf_ds_map_next);
+					if (TAILQ_EMPTY(&tp->t_rxdsmaps) ||
+						map->sf_seq_start == tp->rcv_nxt) {
+						TAILQ_INSERT_TAIL(&tp->t_rxdsmaps, map, sf_ds_map_next);
+					} else {
+						goto dropafterack;
+					}
+				} else {
+					TAILQ_INSERT_BEFORE(next_map, map, sf_ds_map_next);
+				}
+
+				///* Walk list of unmapped packets and call tcp_do_segment for
+				 //* segments that belong to the newly created ds_map entry */
+				//uint32_t map_end = map->sf_seq_start + map->ds_map_len;
+				//struct tseg_qent *u_seg, *temp_seg;
+				//TAILQ_FOREACH_SAFE(u_seg, tp->t_unmapped_segq, tqe_q, temp_seg) {
+					//uint32_t seqnum = u_seg->tqe_th->th_seq;
+					//if ((seqnum >= map->sf_seq_start && map_end > map->sf_seq_start
+						//&& seqnum < map_end) ||
+						//(map_end < map->sf_seq_start && seqnum < map->sf_seq_start
+						//&& seqnum < map_end) ||
+						//(map_end < map->sf_seq_start && seqnum >= map->sf_seq_start
+						//&& seqnum <= UINT_MAX)) {
+							//mp_debug(DSMAP, 1, 0, "found map for unmapped "
+							//"segment: ds_map_start %ju, sd_seq_start: %u. len: "
+							//"%d\n", map->ds_map_start, map->sf_seq_start,
+							//map->ds_map_len);
+
+							//printf("found map for unmapped "
+							//"segment: map_sf_seq_start: %u. len: "
+							//"%d, seqn: %u\n", map->sf_seq_start,
+							//map->ds_map_len, seqnum);
+
+							///*
+							 //* We have the map for this packet. call
+							 //* tcp_do_segment then remove from list.
+							 //* This will process the segment as would have
+							 //* happened if it arrived after the map.
+							 //*
+							 //* XXXNJW:
+							 //* Ideally we should process the just-arrived seg
+							 //* first, so that these buffered segments do have
+							 //* to wait in reassembly.
+							 //*/
+							//INP_WLOCK_ASSERT(tp->t_inpcb);
+							//tcp_do_segment(u_seg->tqe_m, u_seg->tqe_th, so, tp,
+							    //drop_hdrlen, u_seg->tqe_len,
+							    //iptos, ti_locked);
+							//TAILQ_REMOVE(tp->t_unmapped_segq, u_seg, tqe_q);
+							//uma_zfree(V_tcp_unmapped_zone, u_seg);
+							//continue;
+					//}
+				//}
+			}
+			/*
+			 * If in direct mapping mode and have received a DSS, then
+			 * change ds_rcv_nxt to the incoming DSN. We are no longer
+			 * in direct map mode at this point.
+			 * XXXNJW: Shared data access
+			 */
+			if (tp->infinite_map) {
+				tp->t_mpcb->ds_rcv_nxt = to.to_mopts.data_seq_num;
+				tp->infinite_map = 0;
+			}
+		}
+	} /* End DSS Map processing */
+
+	/*
+	 * Processing ADD_ADDR options. This will add the new remote address
+	 * to the path manager, making it available for this mp connection.
+	 * Usually a server might advertise additional address that a client
+	 * can connect to.
+	 */
+	if (to.to_mopts.mpo_flags & (MPOF_ADD_ADDR_V4 | MPOF_ADD_ADDR_V6)) {
+		/* insert into list of usable addresses at index AddrID */
+		/* store the in_addr in the sockaddr_storage */
+
+		bcopy(&to.to_mopts.new_addr,
+		    &mp->mp_added_addresses[to.to_mopts.addr_id],
+		    sizeof(struct sockaddr_storage));
+
+		char buf[128];
+		inet_ntop(AF_INET, &(((struct sockaddr_in *)
+		    &mp->mp_added_addresses[to.to_mopts.addr_id])->sin_addr.s_addr),
+		    buf, sizeof(buf));
+		mp_debug(MPSESSION, 4, 0, "added address %s\n", buf);
+
+		inet_ntop(AF_INET, &(((struct sockaddr_in *)
+			&to.to_mopts.new_addr)->sin_addr.s_addr),
+			buf, sizeof(buf));
+		mp_debug(MPSESSION, 4, 0, "got address %s\n", buf);
+
+		/* XXXNJW: This is a hack in lieu of a proper path manager. prevents
+		 * a multi-homed host from  from attempting to MP_JOIN to any
+		 * addresses it has received via ADD_ADDR */
+		if (tp->t_mpcb->mp_conn_address_count == 1 ||
+		      (tp->t_mpcb->mp_conn_address_count > 1
+			      && !tp->t_mpcb->passive_open) ) {
+			/*
+			 * we have a new address to attempt to join. Increment the advjoin
+			 * and address count, schedule a task to perform a join
+			 * We increment added_address_count _after_ the bitshift so that
+			 * the shift is by the correct amount
+			 */
+			tp->t_mpcb->mp_advjoin_mask |=
+			    (1 << (tp->t_mpcb->mp_added_address_count));
+			atomic_add_int(&tp->t_mpcb->mp_added_address_count,1);
+			mp_debug(MPSESSION, 4, 0, "%s: advjoinmask: %u\n", __func__,
+			    tp->t_mpcb->mp_advjoin_mask);
+		} else {
+
+		}
+	}
+
+	if (tlen) {
+		/*
+		 * Tag the mbuf with data-level sequence number. A direct
+		 * map will map the tcp sequence number directly to the
+		 * data sequence number. Otherwise calculate the dsn and
+		 * tag the mbuf with this value.
+		 *
+		 * XXXNJW: mtag might not be required, see tcp_reass code.
+		 */
+		struct dsn_tag *dtag = (struct dsn_tag *)
+					m_tag_alloc(PACKET_COOKIE_MPTCP,
+					PACKET_TAG_DSN, DSN_LEN, M_NOWAIT); // space for 64-bit DSN
+		struct m_tag *mtag = &dtag->tag;
+
+		//XXXNJW: shared data access
+		if (tp->infinite_map) {
+			dtag->dsn = th->th_seq;
+		} else {
+			if (map == NULL) {
+				/* find the map that this segment belongs to. First map that
+				 * incoming subflow seq num is larger than */
+				TAILQ_FOREACH(map, &tp->t_rxdsmaps, sf_ds_map_next) {
+					/*
+					 * XXXNJW: The following panic needs to be changed to handle
+					 * the buffering of packets beyond the mapped area (for cases where
+					 * the DSN-carrying packet has been lost, or arrives out of order.
+					 *
+					 * XXXNJW: Collapse this into a single block once verified
+					 */
+//					if (map->sf_seq_start + map->ds_map_len > map->sf_seq_start) {
+//						if (th->th_seq > map->sf_seq_start + map->ds_map_len)
+//							panic("%s: Received data beyond end of mapped region."
+//							"ssn: %u, mapstart %u, maplen %u\n",
+//							__func__, th->th_seq, map->sf_seq_start, map->ds_map_len);
+//					} else {
+//						if ((th->th_seq > map->sf_seq_start + map->ds_map_len) &&
+//						    (th->th_seq < map->sf_seq_start))
+//							panic("%s: Received data beyond end of mapped region."
+//							"ssn: %u, mapstart %u, maplen %u\n",
+//							__func__, th->th_seq, map->sf_seq_start, map->ds_map_len);
+//					}
+
+					uint32_t seqnum = th->th_seq;
+					uint32_t sf_seq_end = map->sf_seq_start + map->ds_map_len;
+					if ((seqnum >= map->sf_seq_start && sf_seq_end > map->sf_seq_start
+						&& seqnum < sf_seq_end) ||
+						(sf_seq_end < map->sf_seq_start && seqnum < map->sf_seq_start
+						&& seqnum < sf_seq_end) ||
+						(sf_seq_end < map->sf_seq_start && seqnum >= map->sf_seq_start
+						&& seqnum <= UINT_MAX)) {
+							/* A map exists for this packet */
+							mp_debug(DSMAP, 4, 0, "found map: ds_map_start %ju, "
+							"sd_seq_start: %u. len: %d\n", map->ds_map_start,
+							map->sf_seq_start, map->ds_map_len);
+							break;
+					}
+				}
+
+			}
+
+			/* Must have a valid map beyond this point */
+//			KASSERT(map != NULL, ("%s:%d No map found for packet with "
+//			    "length %d, mp_active is: %d: ssn: %u\n",
+//			    __func__, __LINE__, tlen, tp->mp_active, th->th_seq));
+
+			/*
+			 * In multi-packet map scenario, the packet carrying the map
+			 * might be lost. Thus packets arriving after this will not
+			 * belong to an existing map. These packets are buffered while
+			 * we wait for the packet with the map to be retransmitted.
+			 * If the zone for buffering packets is exhausted, we simply send
+			 * and ACK and drop the segment, making the sender retransmit.
+			 * Otherwise we insert the segment into the list.
+			 */
+			if(map == NULL) {
+				mp_debug(DSMAP, 4, 0,"%s: no map, dropping segment %u dsn: %u\n"
+				    , __func__, th->th_seq, (uint32_t) to.to_mopts.data_seq_num);
+				struct tseg_qent *te = NULL;
+				te = uma_zalloc(V_tcp_unmapped_zone, M_NOWAIT);
+				if (te == NULL) {
+						goto dropafterack;
+				}
+
+				/* XXXNJW not yet handling unmapped packets */
+				goto dropafterack;
+
+				te->tqe_m = m;
+				te->tqe_th = th;
+				te->tqe_len = tlen;
+				te->tqe_dsn = 0;
+
+				/* Push packet into unmapped list and trigger ACK */
+				TAILQ_INSERT_HEAD(tp->t_unmapped_segq, te, tqe_q);
+				tp->t_flags |= TF_ACKNOW;
+				tcp_output(tp);
+				goto check_delack;
+			}
+
+			/* update mbuf tag with current data seq num */
+			dtag->dsn = map->ds_map_start + (th->th_seq - map->sf_seq_start);
+		}
+
+		/* And prepend the mtag to mbuf, to be checked in reass */
+		m_tag_prepend(m, mtag);
+	} /* End tlen > 0 */
+
+	/*
 	 * Process options only when we get SYN/ACK back. The SYN case
 	 * for incoming connections is handled in tcp_syncache.
 	 * According to RFC1323 the window field in a SYN (i.e., a <SYN>
 	 * or <SYN,ACK>) segment itself is never scaled.
-	 * XXX this is traditional behavior, may need to be cleaned up.
+	 * XXX this is traditional behaviour, may need to be cleaned up.
+	 */
+
+	/*
+	 * XXXNJW: There is some access to shared mpcb structure in here.
 	 */
 	if (tp->t_state == TCPS_SYN_SENT && (thflags & TH_SYN)) {
 		if ((to.to_flags & TOF_SCALE) &&
@@ -1614,7 +2505,69 @@
 		if ((tp->t_flags & TF_SACK_PERMIT) &&
 		    (to.to_flags & TOF_SACKPERM) == 0)
 			tp->t_flags &= ~TF_SACK_PERMIT;
-	}
+
+		if (to.to_flags & TOF_MPTCP) {
+			if (IS_MASTER_TP(tp)) {
+				if (tp->sent_capable) {
+					mp_process_remote_key(tp->t_mpcb, to.to_mopts.remote_key);
+
+					/* send mp_cabable ACK, got SYN/ACK. NOTE this is
+					 * different to JOIN_SYNACK */
+					tp->sf_flags |= SFF_GOT_SYNACK;
+					/* we know the other end is mp enabled */
+					tp->mpc = 1;
+					/* enable csum if remote end sets csum bit */
+					if (to.to_mopts.mpo_flags & MPOF_USE_CSUM)
+						tp->t_mpcb->csum_enabled = 1;
+				} else {
+					/* got a MP_CAPABLE but did not send this option */
+					tp->mpc = 1;
+					tp->mp_active = 0;
+				}
+			} else {
+				/* could be a subflow SYN/ACK */
+				if (to.to_mopts.mpo_flags & MPOF_JOIN_SYNACK) {
+					if (to.to_mopts.mpo_flags & MPOF_BACKUP_PATH) {
+						// XXXNJW tbd: this flow is a backup path
+						// should drop the subflow rather than panic the
+						// host
+						panic("Backup subflows not supported yet\n");
+					}
+
+					/* mp is available on this flow */
+					tp->mpc = 1;
+
+					tp->hmac_trun_remote = to.to_mopts.snd_trc_mac;
+					tp->remote_rand = to.to_mopts.snd_rnd;
+
+					/* Calculate a MAC to return in the MP_JOIN ACK using
+					 * the random number just rcvd, and the keys from the
+					 * initial mp establishment
+					 */
+
+					/* MAC-A */
+					uint32_t mac_len = mp_get_hmac(tp->hmac_local,
+					    mp->local_key, mp->remote_key, tp->local_rand,
+					    tp->remote_rand);
+
+					if (mac_len == 0) {
+						mp_debug(MPSESSION, 4, 0,"%s: error computing MAC-A\n",
+						    __func__);
+						goto dropwithreset;
+					}
+
+					// XXXNJW: Need to validate the HMACs before continuing
+					// i.e. calculate the remote hmac and compare the leftmost
+					// 64 bits with the those in the truncated HMAC
+
+					tp->sf_flags |= SFF_GOT_JOIN_SYNACK;
+					mp_debug(MPSESSION, 4, 0,"%s: got join syn/ack\n",
+					    __func__);
+				}
+			}
+		}
+
+	} /* End SYN/ACK processing */
 
 	/*
 	 * Header prediction: check for the two common cases
@@ -1639,7 +2592,7 @@
 	    tp->snd_nxt == tp->snd_max &&
 	    tiwin && tiwin == tp->snd_wnd && 
 	    ((tp->t_flags & (TF_NEEDSYN|TF_NEEDFIN)) == 0) &&
-	    LIST_EMPTY(&tp->t_segq) &&
+	    !tp->t_segq->disordered &&									// XXXNJW: check disordered
 	    ((to.to_flags & TOF_TS) == 0 ||
 	     TSTMP_GEQ(to.to_tsval, tp->ts_recent)) ) {
 
@@ -1704,27 +2657,44 @@
 					tcp_xmit_timer(tp,
 							ticks - tp->t_rtttime);
 				}
-				acked = BYTES_THIS_ACK(tp, th);
 
 				/* Run HHOOK_TCP_ESTABLISHED_IN helper hooks. */
 				hhook_run_tcp_est_in(tp, th, &to);
 
 				TCPSTAT_INC(tcps_rcvackpack);
-				TCPSTAT_ADD(tcps_rcvackbyte, acked);
-				sbdrop(&so->so_snd, acked);
+				TCPSTAT_ADD(tcps_rcvackbyte, acked); // pure ack for outstanding
 				if (SEQ_GT(tp->snd_una, tp->snd_recover) &&
 				    SEQ_LEQ(th->th_ack, tp->snd_recover))
 					tp->snd_recover = th->th_ack - 1;
 				
+				mp_debug(MPSESSION, 3, 0, "%s: sb_cc: %u sb_actual: %u th_ack: "
+						"%u, snd_una: %u acked: %d: \n",
+					__func__, so->so_snd.sb_cc, so->so_snd.sb_actual,
+					th->th_ack, tp->snd_una, acked);
+
 				/*
 				 * Let the congestion control algorithm update
 				 * congestion control related information. This
 				 * typically means increasing the congestion
 				 * window.
 				 */
-				cc_ack_received(tp, th, CC_ACK);
+				cc_ack_received(tp, th, CC_ACK, acked);
+
+				/* Can't have an ACK of a FIN here, so do not need to adjust
+				 * by one byte here.
+				 * XXX: This is also a temporary hack and should be changed
+				 */
+				if (tp->infinite_map) {
+					KASSERT(acked <=  so->so_snd.sb_cc,
+					    ("%s:%d: sb_cc: %d, acked: %d", __func__, __LINE__,
+					    so->so_snd.sb_cc, acked));
+					    atomic_subtract_int(&so->so_snd.sb_cc, acked);
+				}
+				tcp_ackmap(tp, acked, (to.to_mopts.mpo_flags & MPOF_DATA_ACK)
+				    ? to.to_mopts.data_ack_num : 0);
 
 				tp->snd_una = th->th_ack;
+
 				/*
 				 * Pull snd_wl2 up to prevent seq wrap relative
 				 * to th_ack.
@@ -1754,14 +2724,18 @@
 				else if (!tcp_timer_active(tp, TT_PERSIST))
 					tcp_timer_activate(tp, TT_REXMT,
 						      tp->t_rxtcur);
-				sowwakeup(so);
-				if (so->so_snd.sb_cc)
+
+				/* XXXNJW: macro for the first condition below (i.e. unmapped data in sb) */
+				if (SB_NUNMAPPED(&so->so_snd, mp) > 0
+				    || (TAILQ_FIRST(&tp->t_txdsmaps) != NULL &&
+				    !(TAILQ_FIRST(&tp->t_txdsmaps)->flags & MAPF_IS_SENT)))
 					(void) tcp_output(tp);
 				goto check_delack;
 			}
+			/* End pure ACK processing */
 		} else if (th->th_ack == tp->snd_una &&
-		    tlen <= sbspace(&so->so_rcv)) {
-			int newsize = 0;	/* automatic sockbuf scaling */
+		    tlen <= sbspace(&so->so_rcv)) { //XXXNJW okay to base off of sb_cc/ sb_max, sb_mcnt?
+//			int newsize = 0;	/* automatic sockbuf scaling */
 
 			/*
 			 * This is a pure, in-sequence data packet with
@@ -1776,7 +2750,6 @@
 			if ((tp->t_flags & TF_SACK_PERMIT) && tp->rcv_numsacks)
 				tcp_clean_sackreport(tp);
 			TCPSTAT_INC(tcps_preddat);
-			tp->rcv_nxt += tlen;
 			/*
 			 * Pull snd_wl1 up to prevent seq wrap relative to
 			 * th_seq.
@@ -1789,7 +2762,7 @@
 			tp->rcv_up = tp->rcv_nxt;
 			TCPSTAT_INC(tcps_rcvpack);
 			TCPSTAT_ADD(tcps_rcvbyte, tlen);
-			ND6_HINT(tp);	/* Some progress has been made */
+			//ND6_HINT(tp);	/* Some progress has been made */
 #ifdef TCPDEBUG
 			if (so->so_options & SO_DEBUG)
 				tcp_trace(TA_INPUT, ostate, tp,
@@ -1828,45 +2801,58 @@
 		 * TODO: Only step up if the application is actually serving
 		 * the buffer to better manage the socket buffer resources.
 		 */
-			if (V_tcp_do_autorcvbuf &&
-			    to.to_tsecr &&
-			    (so->so_rcv.sb_flags & SB_AUTOSIZE)) {
-				if (TSTMP_GT(to.to_tsecr, tp->rfbuf_ts) &&
-				    to.to_tsecr - tp->rfbuf_ts < hz) {
-					if (tp->rfbuf_cnt >
-					    (so->so_rcv.sb_hiwat / 8 * 7) &&
-					    so->so_rcv.sb_hiwat <
-					    V_tcp_autorcvbuf_max) {
-						newsize =
-						    min(so->so_rcv.sb_hiwat +
-						    V_tcp_autorcvbuf_inc,
-						    V_tcp_autorcvbuf_max);
-					}
-					/* Start over with next RTT. */
-					tp->rfbuf_ts = 0;
-					tp->rfbuf_cnt = 0;
-				} else
-					tp->rfbuf_cnt += tlen;	/* add up */
-			}
+
+			/*
+			 * XXXNJW: Auto buffer tuning may not work as we no longer store
+			 * things in the socket buffers
+			 */
+//			if (V_tcp_do_autorcvbuf &&
+//			    to.to_tsecr &&
+//			    (so->so_rcv.sb_flags & SB_AUTOSIZE)) {
+//				if (TSTMP_GT(to.to_tsecr, tp->rfbuf_ts) &&
+//				    to.to_tsecr - tp->rfbuf_ts < hz) {
+//					if (tp->rfbuf_cnt >
+//					    (so->so_rcv.sb_hiwat / 8 * 7) &&
+//					    so->so_rcv.sb_hiwat <
+//					    V_tcp_autorcvbuf_max) {
+//						newsize =
+//						    min(so->so_rcv.sb_hiwat +
+//						    V_tcp_autorcvbuf_inc,
+//						    V_tcp_autorcvbuf_max);
+//					}
+//					/* Start over with next RTT. */
+//					tp->rfbuf_ts = 0;
+//					tp->rfbuf_cnt = 0;
+//				} else
+//					tp->rfbuf_cnt += tlen;	/* add up */
+//			}
+
+			/* XXXNJW leaving auto scaling code in as need to revisit the
+			 * rcv buffer at some point */
 
 			/* Add data to socket buffer. */
-			SOCKBUF_LOCK(&so->so_rcv);
+			//SOCKBUF_LOCK(&so->so_rcv);
 			if (so->so_rcv.sb_state & SBS_CANTRCVMORE) {
 				m_freem(m);
+				//SOCKBUF_UNLOCK(&so->so_rcv);
 			} else {
 				/*
 				 * Set new socket buffer size.
 				 * Give up when limit is reached.
 				 */
-				if (newsize)
-					if (!sbreserve_locked(&so->so_rcv,
-					    newsize, so, NULL))
-						so->so_rcv.sb_flags &= ~SB_AUTOSIZE;
+//				if (newsize)
+//					if (!sbreserve_locked(&so->so_rcv,
+//					    newsize, so, NULL))
+//						so->so_rcv.sb_flags &= ~SB_AUTOSIZE;
 				m_adj(m, drop_hdrlen);	/* delayed header drop */
-				sbappendstream_locked(&so->so_rcv, m);
+
+				/*
+				 * tcp_reass will aquire lock only if it needs to do
+				 * reassembly.
+				 */
+				//SOCKBUF_UNLOCK(&so->so_rcv);
+				thflags = tcp_reass(tp, th, &tlen, m);
 			}
-			/* NB: sorwakeup_locked() does an implicit unlock. */
-			sorwakeup_locked(so);
 			if (DELAY_ACK(tp, tlen)) {
 				tp->t_flags |= TF_DELACK;
 			} else {
@@ -1875,17 +2861,28 @@
 			}
 			goto check_delack;
 		}
-	}
+	} /* End fast path (TCPS_ESTABLISHED) */
 
 	/*
 	 * Calculate amount of space in receive window,
 	 * and then do TCP input processing.
 	 * Receive window is amount of space in rcv queue,
 	 * but not less than advertised window.
+	 *
+	 * XXXNJW: When mptcp is active, want to use the
+	 * connection-level receive window, stored in the
+	 * mpcb.
 	 */
-	win = sbspace(&so->so_rcv);
+	//win = sbspace(&so->so_rcv);
+
+//	if (tp->mp_active)
+		win = mp_get_recwin(tp->t_mpcb);
+//	else
+//		win = sbspace(&so->so_rcv);
+
 	if (win < 0)
-		win = 0;
+        win = 0;
+
 	tp->rcv_wnd = imax(win, (int)(tp->rcv_adv - tp->rcv_nxt));
 
 	/* Reset receive buffer auto scaling when not in bulk receive mode. */
@@ -1896,7 +2893,7 @@
 
 	/*
 	 * If the state is SYN_RECEIVED:
-	 *	if seg contains an ACK, but not for our SYN/ACK, send a RST.
+	 * if seg contains an ACK, but not for our SYN/ACK, send a RST.
 	 */
 	case TCPS_SYN_RECEIVED:
 		if ((thflags & TH_ACK) &&
@@ -1931,14 +2928,21 @@
 		if ((thflags & (TH_ACK|TH_RST)) == (TH_ACK|TH_RST)) {
 			TCP_PROBE5(connect__refused, NULL, tp,
 			    mtod(m, const char *), tp, th);
-			tp = tcp_drop(tp, ECONNREFUSED);
+			if (IS_MASTER_TP(tp))	//workaround to prevent failed JOINs killing the connection
+			    tp = tcp_drop(tp, ECONNREFUSED);
 		}
 		if (thflags & TH_RST)
 			goto drop;
 		if (!(thflags & TH_SYN))
 			goto drop;
 
+		/* Set initial receive values for tpcb and mpcb. initially we
+		 * are in infinite mapping mode so both key off tp->irs.
+		 * mp protocol specifies increment by 1, for some reason. */
 		tp->irs = th->th_seq;
+		if (IS_MASTER_TP(tp))
+			tp->t_mpcb->ds_rcv_nxt = tp->irs + 1;
+
 		tcp_rcvseqinit(tp);
 		if (thflags & TH_ACK) {
 			TCPSTAT_INC(tcps_connects);
@@ -1954,6 +2958,7 @@
 			tp->rcv_adv += imin(tp->rcv_wnd,
 			    TCP_MAXWIN << tp->rcv_scale);
 			tp->snd_una++;		/* SYN is acked */
+
 			/*
 			 * If there's data, delay ACK; if there's also a FIN
 			 * ACKNOW will be turned on later.
@@ -1968,7 +2973,7 @@
 				tp->t_flags |= TF_ECN_PERMIT;
 				TCPSTAT_INC(tcps_ecn_shs);
 			}
-			
+
 			/*
 			 * Received <SYN,ACK> in SYN_SENT[*] state.
 			 * Transitions:
@@ -1987,6 +2992,19 @@
 				cc_conn_init(tp);
 				tcp_timer_activate(tp, TT_KEEP,
 				    TP_KEEPIDLE(tp));
+				if (to.to_flags & TOF_MPTCP) {
+					if (tp->sent_capable) {
+						/* active open */
+
+						/*  XXXNJW shared access. might be okay as only one
+						 * subflow will exist at this point? (this would make
+						 * the below check irrelevent though... */
+
+						/* Don't want a new subflow to switch the mp state */
+						if(IS_MASTER_TP(tp))
+							mp_init_established(tp);
+					}
+				}
 			}
 		} else {
 			/*
@@ -2035,6 +3053,8 @@
 
 		goto step6;
 
+	/* Case SYN_SENT */
+
 	/*
 	 * If the state is LAST_ACK or CLOSING or TIME_WAIT:
 	 *      do normal processing.
@@ -2045,6 +3065,8 @@
 	case TCPS_CLOSING:
 		break;  /* continue normal processing */
 	}
+	/* End SYN/LISTEN processing */
+
 
 	/*
 	 * States other than LISTEN or SYN_SENT.
@@ -2155,6 +3177,8 @@
 		}
 		goto drop;
 	}
+	/* End RST Processing */
+
 
 	/*
 	 * RFC 1323 PAWS: If we have a timestamp reply on this segment
@@ -2199,6 +3223,7 @@
 		goto dropwithreset;
 	}
 
+	/* Trimming to fit rcv window */
 	todrop = tp->rcv_nxt - th->th_seq;
 	if (todrop > 0) {
 		/*
@@ -2238,16 +3263,27 @@
 			TCPSTAT_INC(tcps_rcvpartduppack);
 			TCPSTAT_ADD(tcps_rcvpartdupbyte, todrop);
 		}
+
 		drop_hdrlen += todrop;	/* drop from the top afterwards */
 		th->th_seq += todrop;
 		tlen -= todrop;
+
+		/* dsn should be incremented by the same length as th_seq */
+		if (map) {
+			struct m_tag *mtag =  m_tag_locate(m, PACKET_COOKIE_MPTCP,
+			    PACKET_TAG_DSN, NULL);
+			KASSERT(mtag != NULL, ("%s segment %u missing an mbuf tag\n",
+			    __func__, th->th_seq - todrop));
+			((struct dsn_tag *)mtag)->dsn += todrop;
+		}
+
 		if (th->th_urp > todrop)
 			th->th_urp -= todrop;
 		else {
 			thflags &= ~TH_URG;
 			th->th_urp = 0;
 		}
-	}
+	} /* end segment trimming, seq < rcv_nxt */
 
 	/*
 	 * If new data are received on a connection after the
@@ -2278,6 +3314,10 @@
 	 */
 	todrop = (th->th_seq + tlen) - (tp->rcv_nxt + tp->rcv_wnd);
 	if (todrop > 0) {
+//		printf("%s: tseq: %u trim %d, window %ld mp %p\n", __func__,
+//		    th->th_seq, todrop, tp->rcv_wnd, tp->t_mpcb);
+//		printf("mp %p tp %p\n", mp, tp);
+//		kdb_break();
 		TCPSTAT_INC(tcps_rcvpackafterwin);
 		if (todrop >= tlen) {
 			TCPSTAT_ADD(tcps_rcvbyteafterwin, tlen);
@@ -2295,6 +3335,7 @@
 				goto dropafterack;
 		} else
 			TCPSTAT_ADD(tcps_rcvbyteafterwin, todrop);
+																				goto dropafterack; //XXXNJW cheap hack test
 		m_adj(m, -todrop);
 		tlen -= todrop;
 		thflags &= ~(TH_PUSH|TH_FIN);
@@ -2373,13 +3414,23 @@
 		if ((tp->t_flags & (TF_RCVD_SCALE|TF_REQ_SCALE)) ==
 			(TF_RCVD_SCALE|TF_REQ_SCALE)) {
 			tp->rcv_scale = tp->request_r_scale;
-			tp->snd_wnd = tiwin;
+
+			if(IS_MASTER_TP(tp)) {
+				tp->snd_wnd = tiwin;
+				// store the unscaled value in mpcb
+				tp->t_mpcb->ds_snd_wnd = (uint32_t) (tiwin >> tp->snd_scale);
+			} else {
+				// set it to the existing window for the connection
+				tp->snd_wnd = tp->t_mpcb->ds_snd_wnd;
+			}
 		}
 		/*
 		 * Make transitions:
 		 *      SYN-RECEIVED  -> ESTABLISHED
 		 *      SYN-RECEIVED* -> FIN-WAIT-1
 		 */
+		oursynisacked = 1;
+
 		tp->t_starttime = ticks;
 		if (tp->t_flags & TF_NEEDFIN) {
 			tcp_state_change(tp, TCPS_FIN_WAIT_1);
